<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004-2005 by Dirk Randhahn                                 |
 | http://www.phpMyBackupPro.net											|
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

// login is not loaded, because of scheduled backups
@session_start();
include_once("definitions.php");

// set the timelimit
@set_time_limit($CONF['timelimit']);
ignore_user_abort(TRUE);

// used variables
if (!isset($argv)) $argv=FALSE;
if (!isset($_GET['incl'])) $_GET['incl']=FALSE;
if (!isset($_POST['db'])) $_POST['db']=FALSE;
if (!isset($_POST['tables'])) $_POST['tables']=FALSE;
if (!isset($_POST['data'])) $_POST['data']=FALSE;
if (!isset($_POST['zip'])) $_POST['zip']=FALSE;
if (!isset($_POST['drop'])) $_POST['drop']=FALSE;
if (!isset($_POST['man_dirs'])) $_POST['man_dirs']=FALSE;
if (!isset($_POST['comments'])) $_POST['comments']=FALSE;

if (!isset($_SESSION['LOGGED_IN'])) $_SESSION['LOGGED_IN']=FALSE;

// is shell mode or web-based mode or export-script mode used or is user not logged in?
if ($argv[1]) {
    $mode="shell";
    $_POST['db']=$argv[1];
    if (isset($argv[2])) {
        if ($argv[2]) $_POST['tables']="on"; else $_POST['tables']="off";
    } else $_POST['tables']="off";
    if (isset($argv[3])) {
	    if ($argv[3]) $_POST['data']="on"; else $_POST['data']="off";
    } else $_POST['data']="off";
    if (isset($argv[4])) {
    	if ($argv[4]) $_POST['drop']="on"; else $_POST['drop']="off";
    } else $_POST['drop']="off";
    if (isset($argv[5])) {
    	if ($argv[5]) $_POST['zip']="gzip"; else $_POST['zip']="off";
    } else  $_POST['zip']="off";
	if (isset($argv[6])) $_POST['man_dirs']=$argv[6]; else $_POST['man_dirs']=false;
    
} elseif (!$_SESSION['LOGGED_IN'] && !$_GET['incl']) {
    $mode="web";
    include("login.php");
} elseif ($_GET['incl']) {
    $mode="incl";
} else {
    $mode="web";
}

// print html if web mode
if ($mode=="web") {
    PMBP_print_header(ereg_replace(".*/","",$_SERVER['SCRIPT_NAME']));

    // if first use or no db-connection possible
    if (!@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'])) echo "<div class=\"red\">".I_SQL_ERROR."</div><br>\n";

	// check if ftp connection is possible
	if (!$CONF['ftp_server']) {
        echo "<div class=\"red\">".C_WRONG_FTP."</div>";
    } elseif (!$conn_id=@ftp_connect($CONF['ftp_server'],$CONF['ftp_port'])) {
        echo "<div class=\"red\">".F_FTP_1." '".$CONF['ftp_server']."'!</div>";
    }
}

// if pressed 'backup' backup the db
if ($_POST['db'] || isset($_POST['dirs']) || strlen($_POST['man_dirs'])) {

    // get start time to calculate duration
	if (function_exists("microtime")) {
		$microtime=explode(" ",microtime());
	    $starttime=($microtime[0]+$microtime[1]);
	} else {
	    $starttime=time();
    }
    
    // delete old backup files
    PMBP_get_backup_files();

    // in shell mode the dbs must be seperated with commas
    if ($mode=="shell") $db_list=explode(",",$_POST['db']); elseif(!isset($_POST['db'][0])) $db_list=FALSE; else $db_list=$_POST['db'];

    // is a database selected?
    if ($db_list) {
        foreach($db_list as $export_db) {

            // generate db dump
            $backupfile=PMBP_dump($export_db,($_POST['tables']=="on"),($_POST['data']=="on"),($_POST['drop']=="on"),$_POST['zip'],$_POST['comments']);

            // is there no db connection or a not existing db?
            if ($backupfile && $backupfile!=="DB_ERROR") {
                // change mod to 0777
                chmod("./".EXPORT_DIR.$backupfile,0777);
                
                // remind filenames if backup by ftp or email is selected
                if (($CONF['email_use'] && function_exists("mail")) || ($CONF['ftp_use'] && function_exists("ftp_connect"))) $store_files[]=$backupfile;

                if ($mode=="web") echo "<div class=\"green\">".EX_SAVED." ".$backupfile."</div>\n"; elseif ($mode=="shell") echo EX_SAVED." ".$backupfile."\n";
            } elseif($backupfile==="DB_ERROR") {
                if ($mode=="web") echo "<div class=\"red\">".C_WRONG_SQL."</div>\n"; elseif ($mode=="shell") echo C_WRONG_SQL."\n";
			} else {
                if ($mode=="web") printf("<div class=\"red\">".EX_NOT_SAVED."</div>\n",$export_db); elseif ($mode=="shell") printf(EX_NOT_SAVED."\n",$export_db);
            }
        }
    } else {
        if ($mode=="web") echo "<div class=\"red\">".EX_NO_DB."</div><br>\n"; elseif ($mode=="shell") echo EX_NO_DB;
    }

    // start backup using ftp or email
    $out=FALSE;
    $backup_info=array("comments"=>$_POST['comments'],"tables"=>($_POST['tables']=="on"),"data"=>($_POST['data']=="on"),"drop"=>($_POST['drop']=="on"),"comp"=>$_POST['zip']);
	if ($CONF['ftp_use'] && isset($store_files)) $out=PMBP_ftp_store($store_files)."\n";
    if ($CONF['email_use'] && isset($store_files)) $out.=PMBP_email_store($store_files,$backup_info);
    
	// file backup per FTP
	if ($CONF['dir_backup'] && (isset($_POST['dirs']) || strlen($_POST['man_dirs']))) {
	    $_POST['man_dirs']= str_replace("\n","",$_POST['man_dirs']);
	    $files=array();
	    $_POST['dirs']=array_merge(explode(",",$_POST['man_dirs']),$_POST['dirs']);
		foreach($_POST['dirs'] as $dir) $files=array_merge($files,PMBP_get_files($dir));
		$out.=PMBP_save_FTP($files);
	}
    if ($mode=="web") {
        echo $out."\n";
        
        // show execution duration
    if (function_exists("microtime")) {
		$microtime=explode(" ",microtime());
	    $endtime=($microtime[0]+$microtime[1]);
	} else {
	    $endtime=time();
    }
        echo "<div class=\"bold\">".F_DURATION.": ".number_format($endtime-$starttime,3)." ".F_SECONDS."</div>\n";
    } elseif ($mode=="shell") {
        echo $out;
        echo F_DURATION.": ".number_format($endtime-$starttime,3)." ".F_SECONDS;
    }


// show the form for selecting a db to backup
} elseif (!$_POST['db'] && $mode=="web") {
    echo "<form action=\"backup.php\" method=\"post\" name=\"backup\">\n<div>\n";
    PMBP_print_export_form();
	echo "\n<input type=\"submit\" value=\"".EX_EXPORT."\" class=\"button\">\n</div>\n</form>\n";
}

// update file list (deletes new generated files if $CONS[del_numer]=0)
PMBP_get_backup_files();

// print html if web mode
if ($mode=="web") PMBP_print_footer();
?>
