<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004-2005 by Dirk Randhahn                                 |
 | http://www.phpMyBackupPro.net											|
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

// ---- adjust these two lines to your file system ----- //

define('GLOBAL_CONF',"./global_conf.php");    // example: define('GLOBAL_CONF',"../../files/global_conf.php");
$_EXPORT_DIR="./export/";             		// example: $_EXPORT_DIR="../../files/export/";

// ---- adjust this line, only if you are going to backup from several database servers or if you have to use different accounts ---- //

define('GLOBAL_CONF_SQL',"./global_conf_sql.php");    // example: define('GLOBAL_CONF',"../../files/global_conf.php");

// ---- no need to modify anything more! ---- //

// definitions
define('VERSION',"v.1.5");  // This is the version number of this phpMyBackupPro copy

define('MAIN_INC',"./functions.inc.php");
define('JAVASCRIPTS',"javascripts.js");
define('STYLESHEET_DIR',"stylesheets/");
define('LANGUAGE_DIR',"language/");
define('IMAGE_DIR',"images/");
define('DATE_DAT',"date.dat");
define('WEBSITE',"http://www.phpMyBackupPro.net");

// includes
if (!@include_once(GLOBAL_CONF)) {
    echo "global_conf.php not found.<br>Please read INSTALL and specify the global_conf.php path in definitions.php.";
    exit;
}

// define arrays (needed for some php installations with safe mode)
$CONF['sql_host_s']=array();
$CONF['sql_user_s']=array();
$CONF['sql_passwd_s']=array();
@include_once(GLOBAL_CONF_SQL);
include_once(MAIN_INC);

// set the working sql server, if several servers are configured
// but not if page login.php or config.php or one og the  help files is loaded
if (count($CONF['sql_passwd_s']) && basename($_SERVER['SCRIPT_FILENAME'])!=="config.php" && basename($_SERVER['SCRIPT_FILENAME'])!=="login.php" && basename($_SERVER['SCRIPT_FILENAME'])!==$CONF['lang']."_help.php") {
	// set working server and register session vars
	if (!isset($_SESSION['sql_host_org'])) $_SESSION['sql_host_org']=$CONF['sql_host'];
	if (!isset($_SESSION['sql_user_org'])) $_SESSION['sql_user_org']=$CONF['sql_user'];
	if (!isset($_SESSION['sql_passwd_org'])) $_SESSION['sql_passwd_org']=$CONF['sql_passwd'];
	if (!isset($_SESSION['wss'])) $_SESSION['wss']=-1;

	if(isset($_POST['mysql_host'])) $_SESSION['wss']=$_POST['mysql_host'];

	// load setting from $_SESSION['wss']
	if ($_SESSION['wss']<0) {
		$CONF['sql_host']=$_SESSION['sql_host_org'];
		$CONF['sql_user']=$_SESSION['sql_user_org'];
		$CONF['sql_passwd']=$_SESSION['sql_passwd_org'];
	} else {
		$CONF['sql_host']=$CONF['sql_host_s'][$_SESSION['wss']];
		$CONF['sql_user']=$CONF['sql_user_s'][$_SESSION['wss']];
		$CONF['sql_passwd']=$CONF['sql_passwd_s'][$_SESSION['wss']];
	}

	// change export directory to sub directory
	@umask(0000);
	@mkdir($_EXPORT_DIR.$CONF['sql_host']."_".$CONF['sql_user'],0777);
	define('EXPORT_DIR',$_EXPORT_DIR.$CONF['sql_host']."_".$CONF['sql_user']."/");
} else {
	define('EXPORT_DIR',$_EXPORT_DIR);
}

// create date.dat if not available
if (!is_writable(EXPORT_DIR."date.dat")) {
	@$dateHandler=fopen(EXPORT_DIR."date.dat","w");
	@fwrite($dateHandler,"0");
	@fclose($dateHandler);
	@chmod(EXPORT_DIR."date.dat",0770);
}

// check if language was just changed in config.php
if (isset($_POST['lang']) && ereg_replace(".*/","",$_SERVER['PHP_SELF'])=="config.php") $CONF['lang']=$_POST['lang'];

// include language.inc.php
if (!file_exists("./".LANGUAGE_DIR.$CONF['lang'].".inc.php")) include_once("./".LANGUAGE_DIR."english.inc.php"); else include("./".LANGUAGE_DIR.$CONF['lang'].".inc.php");

// set local time to defined or environment var value
$tmp=phpversion();
$phpvers=$tmp[0].$tmp[1].$tmp[2];
if (defined("BD_LANG_SHORTCUT") AND $phpvers>=4.3) setlocale(LC_TIME,BD_LANG_SHORTCUT,BD_LANG_SHORTCUT."_".strtoupper('BD_LANG_SHORTCUT')); else setlocale(LC_TIME,"");

// special part for arabic language
if ($CONF['lang']=="arabic") define('ARABIC_HTML'," dir=\"rtl\""); else define('ARABIC_HTML',"");
?>
